#!/usr/bin/env ruby

require "pry"
# require "sinatra"
require "sinatra/cookies"
require 'sinatra/base'
require "slim"
require "bcrypt"
require 'jwt'
require "sequel"

module LifePex
  DB = Sequel.connect ARGV[0] || ENV["LIFEPEX_DB"] || "sqlite://sqlite.db"
  SECRET = ENV['LIFEPEX_SECRET'] || "LifePexSecret"
end

require_relative "./models/level.rb"
require_relative "./models/user.rb"
require_relative "./models/pex.rb"
require_relative "./models/user_pex.rb"

require_relative "./auth.rb"
require_relative "./users.rb"
require_relative "./pex.rb"

class PublicSystem < Sinatra::Base
  set :public_folder, 'public'
end

class BaseSystem < Sinatra::Base
  use AuthSystem
  use PublicSystem
  use PexSystem
  use UserSystem
  run! if app_file == $0
end
